function StrReplace(Find,ReplaceS,Original){
  re = new RegExp(Find,"g");
  return Original.replace(re,ReplaceS);  
}

function GetIdentifier(input,num){
  var listofitems=input.split('_');
  if (num<listofitems.length) {
    return listofitems[num];
  } else {
    return "";
  }
}

function GetHoursValue(minutesvalue) {
  var remainder = minutesvalue % 60;
  var quotient = ( minutesvalue - remainder ) / 60;
  return quotient;  
}

function GetMinutesValue(minutesvalue) {
  var remainder = minutesvalue % 60;
  return remainder;  
}


function ReformatString(input,id,rowid){

 // List of solvable variables:
  // %c% = Mailbox name
  // %u% = Unread Count for mailbox
  // %t% = Total Count for mailbox

  // %ld% = Last Update Day
  // %lm% = Last Update month
  // %ly% = Last Update year (2 digits)
  // %lY% = Last Update year (4 digits)
  // %lh% = Last Update hour (12h)
  // %lH% = Last Update hour (24h)
  // %lA% = Last Update AM/PM
  // %lmi% = Last Update minute
  // %ms% = Mailbox status (updating, waiting, error)
  // %mst% = Mailbox status info 
  
  // %mbs% = Mailbox Size (bytes) integer
  // %mbk% = Mailbox Size (kilos) integer
  // %mbM% = Mailbox Size (megas) two digits
  // %mbG% = Mailbox Size (gigas) two digits
  
  // %S1 = Subject of last arrived mail
  // %S2 = Subject of second last arrived mail
  // %S3 = Subject of third last arrived mail
  // %S4 = Subject of fourth last arrived mail
  // %S5 = Subject of fifth last arrived mail
  // %F1 = Same as above, but From-field
  
  // %nh% = Hours to next update
  // %nm% = Minutes to next update
  // %ns% = Seconds to next update
  // %nM% = Minutes to next update (total, 1,5h=90minutes)

  // %h% = Current Time hours (12h)
  // %H% = Current Time hours (24h)
  // %A% = Current Time hours (AM/PM)
  // %mi% = Current Time minutes
  // %s% = Current Time seconds
  // %d% = Current day
  // %m% = Current month
  // %y% = Current year (2 digits)
  // %Y% = Current year (4 digits)

  // %env_[EnvironmentVariable]% = Display Environment Variable (use?)
  
  if (rowid!=-1) {
  
    if (ConditionCheck(0,id,rowid)==false) {
      return "";
    }  
  }  

  d = new Date();
  
  var h=0;
  var m=0;
  var s=0;
  
  var marker="";
  var rplctxt="";
  var minutestoupdate=0;
  
  if (id<SettingsMailboxCurrentInterval.length) {
    minutestoupdate=SettingsMailboxCurrentInterval[id];
  }  
  input=StrReplace("%nh%",GetHoursValue(minutestoupdate),input);
  var minuttemp=GetMinutesValue(minutestoupdate);
  if (minuttemp<10) {
    minuttemp="0"+minuttemp;
  }
  input=StrReplace("%nm%",minuttemp,input);
  input=StrReplace("%ns%","00",input);
  input=StrReplace("%nM%",minutestoupdate,input);  
  

  if (id<SettingsMailboxName.length) {
    input=StrReplace("%c%",SettingsMailboxName[id],input);
  } else {
    input=StrReplace("%c%","",input);
  }  
  
  if (id<MBUnreadCount.length) {
    input=StrReplace("%u%",MBUnreadCount[id],input);
  } else {
    input=StrReplace("%u%","",input);
  }  
  
  if (id<MBTotalCount.length) {
    input=StrReplace("%t%",MBTotalCount[id],input);
  } else {
    input=StrReplace("%t%","",input);
  }  


  for (t=0;t<6;t++) {    
    if ((id<MBMailDataSubject.length) && (t<MBMailDataSubject[id].length)) {
      input=StrReplace("%S"+(t+1)+"%",MBMailDataSubject[id][t],input);
    } else {
      input=StrReplace("%S"+(t+1)+"%","",input);
    }    
    
    
    if ((id<MBMailDataSender.length) && (t<MBMailDataSender[id].length)) {
      input=StrReplace("%F"+(t+1)+"%",MBMailDataSender[id][t],input);
    } else {
      input=StrReplace("%F"+(t+1)+"%","",input);
    }
  }


  var StatusConv="";

  if (id<MBStatus.length) {
    if (MBStatus[id]==0) StatusConv=StatusReady;
    if (MBStatus[id]==1) StatusConv=StatusQueued;
    if (MBStatus[id]==2) StatusConv=StatusUpdating;
    if (MBStatus[id]==3) StatusConv=StatusError;
  } 
  input=StrReplace("%ms%",StatusConv,input);
  
  if (id<MBStatusInfo.length) {
    stattext=MBStatusInfo[id];
    code=0;codetype=0;
    codetype=GetIdentifier(stattext,0);
    code=GetIdentifier(stattext,1);
    if (codetype=="1") {
      if ((ErrorCode[code]!="") && (ErrorCode[code]!=undefined)) {
        input=StrReplace("%mst%",ErrorCode[code],input);
      } else {
        input=StrReplace("%mst%",GetIdentifier(stattext,2),input);
      }
    } else {
      input=StrReplace("%mst%",GetIdentifier(stattext,2),input);
    }
    
  } else {
    input=StrReplace("%mst%","",input);
  }
  
  if (id<MBMailboxSize.length) {
    // %mbs% = Mailbox Size (bytes) integer
    // %mbk% = Mailbox Size (kilos) integer
    // %mbM% = Mailbox Size (megas) two digits
    // %mbG% = Mailbox Size (gigas) two digits    
    var tmpsize=parseInt(MBMailboxSize[id]);
    input=StrReplace("%mbs%",tmpsize,input);
    tmpsizef=tmpsize/1024;    
    input=StrReplace("%mbk%",tmpsizef.toFixed(0),input);
    tmpsizef=tmpsizef/1024;
    input=StrReplace("%mbM%",tmpsizef.toFixed(2),input);
    tmpsizef=tmpsizef/1024;
    input=StrReplace("%mbG%",tmpsizef.toFixed(2),input);
  } else {
    input=StrReplace("%mbs%","",input);
    input=StrReplace("%mbk%","",input);
    input=StrReplace("%mbM%","",input);
    input=StrReplace("%mbG%","",input);
  }
    
  // Last Update Time:
  
  
  h2=parseInt(MBUpdateHour[id]);
  m2=parseInt(MBUpdateMinute[id]);
  
  da2=MBUpdateDay[id];
  mo2=MBUpdateMonth[id];
  ye2=MBUpdateYear[id];
  yes2=MBUpdateYear[id]+"";
  
  if (m2<10) m2="0"+m2;
  
  marker="AM";
  if (h2>12) {
    h2=h2-12;
    marker="PM";
  }


  input=StrReplace("%lh%",h2,input);  
  input=StrReplace("%lH%",MBUpdateHour[id],input);  
  input=StrReplace("%lmi%",m2,input);  
  input=StrReplace("%lA%",marker,input);

  input=StrReplace("%ld%",da2,input);  
  input=StrReplace("%lm%",mo2,input);  
  input=StrReplace("%ly%",yes2.substring(2),input);  
  input=StrReplace("%lY%",ye2,input);  

  // Current Time:

  

  h=d.getHours();
  m=d.getMinutes();
  s=d.getSeconds();
  
  da=d.getDate();
  mo=d.getMonth()+1;
  ye=d.getFullYear();
  yes=String(ye);
  
  if (m<10) m="0"+m;
  if (s<10) s="0"+s;
  
  marker="AM";
  if (h>12) {
    h=h-12;
    marker="PM";
  }

  input=StrReplace("%h%",h,input);  
  input=StrReplace("%H%",d.getHours(),input);  
  input=StrReplace("%mi%",m,input);  
  input=StrReplace("%s%",s,input);
  input=StrReplace("%A%",marker,input);
  
  input=StrReplace("%d%",da,input);  
  input=StrReplace("%m%",mo,input);  
  input=StrReplace("%y%",yes.substring(2),input);  
  input=StrReplace("%Y%",ye,input);  
 
  envpos=input.indexOf("%env_");
  if (envpos!=-1) {
    // We have environment variable to process...
    envname=input.substring(envpos+5);
    envend=envname.indexOf("%");
    envname=envname.substring(0,envend);
    
    var wshShell = new ActiveXObject("WScript.Shell");
    var wshEnv = wshShell.Environment("PROCESS");
    input=StrReplace("%env_"+envname+"%",wshEnv(envname),input);   

  }
 

  if ((rowid<TextDecorationMaxStringLen.length) && (rowid!=-1)) {
    if (TextDecorationMaxStringLen[rowid]!="") {
      input=input.substring(0,TextDecorationMaxStringLen[rowid])
    }
  }
  
  
  return input;
}


function FlyOutReformatString(input,id){

  // List of solvable variables:
  // %c% = Mailbox name
  // %u% = Unread Count for mailbox
  // %t% = Total Count for mailbox

  // %ld% = Last Update Day
  // %lm% = Last Update month
  // %ly% = Last Update year (2 digits)
  // %lY% = Last Update year (4 digits)
  // %lh% = Last Update hour (12h)
  // %lH% = Last Update hour (24h)
  // %lA% = Last Update AM/PM
  // %lmi% = Last Update minute
  // %ms% = Mailbox status (updating, waiting, error)
  // %mst% = Mailbox status info 
  
  // %FlyOutMBs% = Mailbox Size (bytes) integer
  // %FlyOutMBk% = Mailbox Size (kilos) integer
  // %FlyOutMBM% = Mailbox Size (megas) two digits
  // %FlyOutMBG% = Mailbox Size (gigas) two digits
    
  // %nh% = Hours to next update
  // %nm% = Minutes to next update
  // %ns% = Seconds to next update
  // %nM% = Minutes to next update (total, 1,5h=90minutes)
  
  // %uid% = Message Unique Identifier
  // %su% = Message Subject
  // %re% = Is Message Read
  // %se% = Message Sender
  // %to% = Message To
  // %cc% = Message CC
  // %si% = Message Size (bytes)
  // %sik% = Message Size (kilos)
  // %siM% = Message Size (megas)
  // %siG% = Message Size (gigas)
  // %at% = Has Attachments
  // %pr% = Message Priority
  // %rd% = Message Receive Day
  // %rm% = Message Receive Month
  // %ry% = Message Receive Year (2 digits)
  // %rY% = Message Receive Year (4 digits)
  // %rh% = Message Receive hours (12h)
  // %rH% = Message Receive hours (24h)
  // %rmi% = Message Receive minutes
  // %rs% = Message Receive seconds
  // %rA% = Message Receive hours (AM/PM)

  // %h% = Current Time hours (12h)
  // %H% = Current Time hours (24h)
  // %A% = Current Time hours (AM/PM)
  // %mi% = Current Time minutes
  // %s% = Current Time seconds
  // %d% = Current day
  // %m% = Current month
  // %y% = Current year (2 digits)
  // %Y% = Current year (4 digits)

  // %env_[EnvironmentVariable]% = Display Environment Variable (use?)
  
  // %ic_read% = Read Icon
  // %ic_unread% = Unread Icon
  
  // %ic_lowest% = Lowest Priority Icon
  // %ic_low% = Low Priority Icon
  // %ic_normal% = Normal Priority Icon
  // %ic_high% = High Priority Icon
  // %ic_highest% = Highest Priority Icon
  
  // %ic_att% = Attachements Icon
  // %ic_noatt% = No Attachments Icon
  
  // %dst% = Download Status Text
  // %dsp% = Download Status Percentage

  d = new Date();
  
  var h=0;
  var m=0;
  var s=0;
  
  var marker="";
  var rplctxt="";

  var minutestoupdate=0;
 
  minutestoupdate=FlyOutMailboxCurrentInterval;
  // %% = Hours to next update
  // %% = Minutes to next update
  // %% = Seconds to next update
  // %% = Minutes to next update (total, 1,5h=90minutes)  
  input=StrReplace("%nh%",GetHoursValue(minutestoupdate),input);
  var minuttemp=GetMinutesValue(minutestoupdate);
  if (minuttemp<10) {
    minuttemp="0"+minuttemp;
  }
  input=StrReplace("%nm%",minuttemp,input);
  input=StrReplace("%ns%","00",input);
  input=StrReplace("%nM%",minutestoupdate,input);  
 
  
  input=StrReplace("%c%",FlyOutService,input);
  input=StrReplace("%u%",FlyOutMBUnreadCount,input);
  input=StrReplace("%t%",FlyOutMBTotalCount,input);
  
  
  DownloadStatusText="";
  DownloadStatusPercentage="0%";
  if (FlyOutInfoStatus=="0") {
    DownloadStatusText="Downloading message.";
    DownloadStatusPercentage="0%";
  }
  if (FlyOutInfoStatus=="1") {
    DownloadStatusText="Settings retrieved.";
    DownloadStatusPercentage="17%";
  }
  if (FlyOutInfoStatus=="2") {
    DownloadStatusText="Connected to the server.";
    DownloadStatusPercentage="33%";
  }
  if (FlyOutInfoStatus=="3") {
    DownloadStatusText="Message download completed.";
    DownloadStatusPercentage="50%";
  }
  if (FlyOutInfoStatus=="4") {
    DownloadStatusText="Message parse completed.";
    DownloadStatusPercentage="67%";
  }  
  if (FlyOutInfoStatus=="5") {
    DownloadStatusText="Message structure finished.";
    DownloadStatusPercentage="83%";
  }
  if (FlyOutInfoStatus=="6") {
    DownloadStatusText="Rendering mail.";
    DownloadStatusPercentage="90%";
  }
  if (FlyOutInfoStatus=="7") {
    DownloadStatusText="Download completed.";
    DownloadStatusPercentage="100%";
  }
  
  
  if (FlyOutInfoStatus=="99") {
    DownloadStatusText="Download error.";
    DownloadStatusPercentage="100%";
  }
  
  input=StrReplace("%dst%",DownloadStatusText,input);
  input=StrReplace("%dsp%",DownloadStatusPercentage,input);
  
  

  if (id!=-1) {
    // Mail data convert: 
    input=StrReplace("%uid%",FlyOutMBMailDataUID[id],input);
    input=StrReplace("%su%",FlyOutMBMailDataSubject[id],input);
       
    var iconread="";
    var iconunread="";
    
    if (FlyOutMBMailDataIsRead[id]=="Read") {
      IsRead=ReadText;
      iconread="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconRead+"'>";
    } else {
      IsRead=UnReadText;
      iconunread="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconUnread+"'>";
    }
    input=StrReplace("%re%",IsRead,input);
    input=StrReplace("%se%",FlyOutMBMailDataSender[id],input);
    input=StrReplace("%to%",FlyOutMBMailDataTo[id],input);
    input=StrReplace("%cc%",FlyOutMBMailDataCC[id],input);
    var tmpsi=parseInt(FlyOutMBMailDataSize[id]);
    input=StrReplace("%si%",tmpsi,input);
    tmpsi=tmpsi/1024;
    input=StrReplace("%sik%",tmpsi.toFixed(0),input);
    tmpsi=tmpsi/1024;
    input=StrReplace("%siM%",tmpsi.toFixed(2),input);
    tmpsi=tmpsi/1024;
    input=StrReplace("%siG%",tmpsi.toFixed(2),input);
    
    var iconattachment="";
    var iconnoattachment="";
    
    if (FlyOutMBMailDataAttachments[id]!="") {
      IsAttachment=AttachmentText;
      iconattachment="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconAttachments+"'>";    
    } else {
      IsAttachment="";
      iconnoattachment="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconNoAttachments+"'>";
    }
    input=StrReplace("%at%",IsAttachment,input);
    

    priority=NormalText;
    if (FlyOutMBMailDataPriority[id]=="Lowest") priority=LowestText;
    if (FlyOutMBMailDataPriority[id]=="Low") priority=LowText;
    if (FlyOutMBMailDataPriority[id]=="Normal") priority=NormalText;
    if (FlyOutMBMailDataPriority[id]=="High") priority=HighText;
    if (FlyOutMBMailDataPriority[id]=="Highest") priority=HighestText;
    
    var prlowest="";
    var prlow="";
    var prnormal="";
    var prhigh="";
    var prhighest="";
    
    if (FlyOutMBMailDataPriority[id]=="Lowest") prlowest="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconImportancyLowest+"'>";
    if (FlyOutMBMailDataPriority[id]=="Low") prlow="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconImportancyLow+"'>";
    if (FlyOutMBMailDataPriority[id]=="Normal") prnormal="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconImportancyNormal+"'>";
    if (FlyOutMBMailDataPriority[id]=="High") prhigh="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconImportancyHigh+"'>";
    if (FlyOutMBMailDataPriority[id]=="Highest") prhighest="<img src='Themes/"+FlyouytThemeName+"/"+FlyOutIconImportancyHighest+"'>";  

    input=StrReplace("%pr%",priority,input);
    input=StrReplace("%rd%",FlyOutMBMailDataReceiveDay[id],input);
    input=StrReplace("%rm%",FlyOutMBMailDataReceiveMonth[id],input);
    tmpy=FlyOutMBMailDataReceiveYear[id];  
    input=StrReplace("%ry%",tmpy.substring(2),input);
    input=StrReplace("%rY%",tmpy,input);
    
    m=FlyOutMBMailDataReceiveMinute[id];
    s=FlyOutMBMailDataReceiveSecond[id];
    h=FlyOutMBMailDataReceiveHour[id];
    h2=FlyOutMBMailDataReceiveHour[id];
    if (m<10) m="0"+m;
    if (s<10) s="0"+s;
    
    marker="AM";
    if (h>12) {
      h=h-12;
      marker="PM";
    }
    input=StrReplace("%rh%",h,input);
    input=StrReplace("%rH%",h2,input);
    input=StrReplace("%rmi%",m,input);
    input=StrReplace("%rs%",s,input);
    input=StrReplace("%rA%",marker,input);
    
    
    input=StrReplace("%ic_read%",iconread,input);  
    input=StrReplace("%ic_unread%",iconunread,input);  
    
    input=StrReplace("%ic_lowest%",prlowest,input);  
    input=StrReplace("%ic_low%",prlow,input);  
    input=StrReplace("%ic_normal%",prnormal,input);  
    input=StrReplace("%ic_high%",prhigh,input);  
    input=StrReplace("%ic_highest%",prhighest,input);  
    
    input=StrReplace("%ic_att%",iconattachment,input);  
    input=StrReplace("%ic_noatt%",iconnoattachment,input);  



  } else {
    // Set as empty..
    input=StrReplace("%uid%","",input);
    input=StrReplace("%su%","",input);
    input=StrReplace("%%re%","",input);
    input=StrReplace("%se%","",input);
    input=StrReplace("%to%","",input);
    input=StrReplace("%cc%","",input);    
    input=StrReplace("%si%","",input);    
    input=StrReplace("%sik%","",input);    
    input=StrReplace("%siM%","",input);    
    input=StrReplace("%siG%","",input);
    input=StrReplace("%at%","",input);
    input=StrReplace("%pr%","",input);
    input=StrReplace("%rd%","",input);
    input=StrReplace("%rm%","",input);    
    input=StrReplace("%ry%","",input);
    input=StrReplace("%rY%","",input);    
    input=StrReplace("%rh%","",input);
    input=StrReplace("%rH%","",input);
    input=StrReplace("%rmi%","",input);
    input=StrReplace("%rs%","",input);
    input=StrReplace("%rA%","",input);    


    input=StrReplace("%ic_read%","",input);  
    input=StrReplace("%ic_unread%","",input);  
    
    input=StrReplace("%ic_lowest%","",input);  
    input=StrReplace("%ic_low%","",input);  
    input=StrReplace("%ic_normal%","",input);  
    input=StrReplace("%ic_high%","",input);  
    input=StrReplace("%ic_highest%","",input);  
    
    input=StrReplace("%ic_att%","",input);  
    input=StrReplace("%ic_noatt%","",input);  

  }

  var StatusConv="";

  if (FlyOutMBStatus==0) StatusConv=StatusReady;
  if (FlyOutMBStatus==1) StatusConv=StatusQueued;
  if (FlyOutMBStatus==2) StatusConv=StatusUpdating;
  if (FlyOutMBStatus==3) StatusConv=StatusError;
  input=StrReplace("%ms%",StatusConv,input);
  
  stattext=FlyOutMBStatusInfo;
  code=0;codetype=0;
  codetype=GetIdentifier(stattext,0);
  code=GetIdentifier(stattext,1);
  if (codetype=="1") {
    if ((ErrorCode[code]!="") && (ErrorCode[code]!=undefined)) {
      input=StrReplace("%mst%",ErrorCode[code],input);
    } else {
      input=StrReplace("%mst%",GetIdentifier(stattext,2),input);
    }
  } else {
    input=StrReplace("%mst%",GetIdentifier(stattext,2),input);
  }

  
  // %FlyOutMBs% = Mailbox Size (bytes) integer
  // %FlyOutMBk% = Mailbox Size (kilos) integer
  // %FlyOutMBM% = Mailbox Size (megas) two digits
  // %FlyOutMBG% = Mailbox Size (gigas) two digits    
  var tmpsize=parseInt(FlyOutMBMailboxSize);
  input=StrReplace("%mbs%",tmpsize,input);
  tmpsizef=tmpsize/1024;    
  input=StrReplace("%mbk%",tmpsizef.toFixed(0),input);
  tmpsizef=tmpsizef/1024;
  input=StrReplace("%mbM%",tmpsizef.toFixed(2),input);
  tmpsizef=tmpsizef/1024;
  input=StrReplace("%mbG%",tmpsizef.toFixed(2),input);


  // Last Update Time:
  
  
  h2=parseInt(FlyOutMBUpdateHour);
  m2=parseInt(FlyOutMBUpdateMinute);
  
  da2=FlyOutMBUpdateDay;
  mo2=FlyOutMBUpdateMonth;
  ye2=FlyOutMBUpdateYear;
  yes2=FlyOutMBUpdateYear+"";
  
  if (m2<10) m2="0"+m2;
  
  marker="AM";
  if (h2>12) {
    h2=h2-12;
    marker="PM";
  }


  input=StrReplace("%lh%",h2,input);  
  input=StrReplace("%lH%",FlyOutMBUpdateHour,input);  
  input=StrReplace("%lmi%",m2,input);  
  input=StrReplace("%lA%",marker,input);

  input=StrReplace("%ld%",da2,input);  
  input=StrReplace("%lm%",mo2,input);  
  input=StrReplace("%ly%",yes2.substring(2),input);  
  input=StrReplace("%lY%",ye2,input);  


  // Current Time:
  h=d.getHours();
  m=d.getMinutes();
  s=d.getSeconds();
  
  da=d.getDate();
  mo=d.getMonth()+1;
  ye=d.getFullYear();
  yes=String(ye);
  
  if (m<10) m="0"+m;
  if (s<10) s="0"+s;
  
  marker="AM";
  if (h>12) {
    h=h-12;
    marker="PM";
  }

  input=StrReplace("%h%",h,input);  
  input=StrReplace("%H%",d.getHours(),input);  
  input=StrReplace("%mi%",m,input);  
  input=StrReplace("%s%",s,input);
  input=StrReplace("%A%",marker,input);
  
  input=StrReplace("%d%",da,input);  
  input=StrReplace("%m%",mo,input);  
  input=StrReplace("%y%",yes.substring(2),input);  
  input=StrReplace("%Y%",ye,input);  
 
  envpos=input.indexOf("%env_");
  if (envpos!=-1) {
    // We have environment variable to process...
    envname=input.substring(envpos+5);
    envend=envname.indexOf("%");
    envname=envname.substring(0,envend);
    
    var wshShell = new ActiveXObject("WScript.Shell");
    var wshEnv = wshShell.Environment("PROCESS");
    input=StrReplace("%env_"+envname+"%",wshEnv(envname),input);   

  }
 
/*
  if ((rowid<TextDecorationMaxStringLen.length) && (rowid!=-1)) {
    if (TextDecorationMaxStringLen[rowid]!="") {
      input=input.substring(0,TextDecorationMaxStringLen[rowid])
    }
  }
*/
  
  return input;
}